(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('lodash-es')) :
    typeof define === 'function' && define.amd ? define(['exports', 'react', 'lodash-es'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["@weizx/react-tree"] = {}, global.react, global.lodashEs));
})(this, (function (exports, React, lodashEs) { 'use strict';

    /******************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise, SuppressedError, Symbol */


    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
        var e = new Error(message);
        return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
    };

    var CLASS_PREFIX = 'weizx-tree';

    var initialValue = {
      rootId: 0,
      nodeList: [{
        nodeId: 0,
        nodeType: 0,
        nodeTitle: 'title',
        nodeText: 'content',
        disabled: false,
        childrenId: [1, 2]
      }, {
        nodeId: 1,
        nodeType: 0,
        nodeTitle: 'title',
        nodeText: 'content',
        disabled: false
      }, {
        nodeId: 2,
        nodeType: 0,
        nodeTitle: 'title',
        nodeText: 'content',
        disabled: false
      }]
    };

    var basicContext = /*#__PURE__*/React.createContext([initialValue, function () {}]);
    var optionContext = /*#__PURE__*/React.createContext({
      options: {},
      curSelectedNodeId: null,
      setCurSelectedNodeId: function setCurSelectedNodeId() {}
    });

    var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

    function getDefaultExportFromCjs (x) {
    	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
    }

    var fails$b = function (exec) {
      try {
        return !!exec();
      } catch (error) {
        return true;
      }
    };

    var fails$a = fails$b;

    var functionBindNative = !fails$a(function () {
      // eslint-disable-next-line es/no-function-prototype-bind -- safe
      var test = (function () { /* empty */ }).bind();
      // eslint-disable-next-line no-prototype-builtins -- safe
      return typeof test != 'function' || test.hasOwnProperty('prototype');
    });

    var NATIVE_BIND$3 = functionBindNative;

    var FunctionPrototype$1 = Function.prototype;
    var call$5 = FunctionPrototype$1.call;
    var uncurryThisWithBind = NATIVE_BIND$3 && FunctionPrototype$1.bind.bind(call$5, call$5);

    var functionUncurryThis = NATIVE_BIND$3 ? uncurryThisWithBind : function (fn) {
      return function () {
        return call$5.apply(fn, arguments);
      };
    };

    var uncurryThis$b = functionUncurryThis;

    var objectIsPrototypeOf = uncurryThis$b({}.isPrototypeOf);

    var check = function (it) {
      return it && it.Math === Math && it;
    };

    // https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
    var global$a =
      // eslint-disable-next-line es/no-global-this -- safe
      check(typeof globalThis == 'object' && globalThis) ||
      check(typeof window == 'object' && window) ||
      // eslint-disable-next-line no-restricted-globals -- safe
      check(typeof self == 'object' && self) ||
      check(typeof commonjsGlobal == 'object' && commonjsGlobal) ||
      check(typeof commonjsGlobal == 'object' && commonjsGlobal) ||
      // eslint-disable-next-line no-new-func -- fallback
      (function () { return this; })() || Function('return this')();

    var NATIVE_BIND$2 = functionBindNative;

    var FunctionPrototype = Function.prototype;
    var apply$1 = FunctionPrototype.apply;
    var call$4 = FunctionPrototype.call;

    // eslint-disable-next-line es/no-reflect -- safe
    var functionApply = typeof Reflect == 'object' && Reflect.apply || (NATIVE_BIND$2 ? call$4.bind(apply$1) : function () {
      return call$4.apply(apply$1, arguments);
    });

    var uncurryThis$a = functionUncurryThis;

    var toString$1 = uncurryThis$a({}.toString);
    var stringSlice = uncurryThis$a(''.slice);

    var classofRaw$2 = function (it) {
      return stringSlice(toString$1(it), 8, -1);
    };

    var classofRaw$1 = classofRaw$2;
    var uncurryThis$9 = functionUncurryThis;

    var functionUncurryThisClause = function (fn) {
      // Nashorn bug:
      //   https://github.com/zloirock/core-js/issues/1128
      //   https://github.com/zloirock/core-js/issues/1130
      if (classofRaw$1(fn) === 'Function') return uncurryThis$9(fn);
    };

    // https://tc39.es/ecma262/#sec-IsHTMLDDA-internal-slot
    var documentAll = typeof document == 'object' && document.all;

    // `IsCallable` abstract operation
    // https://tc39.es/ecma262/#sec-iscallable
    // eslint-disable-next-line unicorn/no-typeof-undefined -- required for testing
    var isCallable$a = typeof documentAll == 'undefined' && documentAll !== undefined ? function (argument) {
      return typeof argument == 'function' || argument === documentAll;
    } : function (argument) {
      return typeof argument == 'function';
    };

    var objectGetOwnPropertyDescriptor = {};

    var fails$9 = fails$b;

    // Detect IE8's incomplete defineProperty implementation
    var descriptors = !fails$9(function () {
      // eslint-disable-next-line es/no-object-defineproperty -- required for testing
      return Object.defineProperty({}, 1, { get: function () { return 7; } })[1] !== 7;
    });

    var NATIVE_BIND$1 = functionBindNative;

    var call$3 = Function.prototype.call;

    var functionCall = NATIVE_BIND$1 ? call$3.bind(call$3) : function () {
      return call$3.apply(call$3, arguments);
    };

    var objectPropertyIsEnumerable = {};

    var $propertyIsEnumerable = {}.propertyIsEnumerable;
    // eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
    var getOwnPropertyDescriptor$2 = Object.getOwnPropertyDescriptor;

    // Nashorn ~ JDK8 bug
    var NASHORN_BUG = getOwnPropertyDescriptor$2 && !$propertyIsEnumerable.call({ 1: 2 }, 1);

    // `Object.prototype.propertyIsEnumerable` method implementation
    // https://tc39.es/ecma262/#sec-object.prototype.propertyisenumerable
    objectPropertyIsEnumerable.f = NASHORN_BUG ? function propertyIsEnumerable(V) {
      var descriptor = getOwnPropertyDescriptor$2(this, V);
      return !!descriptor && descriptor.enumerable;
    } : $propertyIsEnumerable;

    var createPropertyDescriptor$3 = function (bitmap, value) {
      return {
        enumerable: !(bitmap & 1),
        configurable: !(bitmap & 2),
        writable: !(bitmap & 4),
        value: value
      };
    };

    var uncurryThis$8 = functionUncurryThis;
    var fails$8 = fails$b;
    var classof$4 = classofRaw$2;

    var $Object$3 = Object;
    var split = uncurryThis$8(''.split);

    // fallback for non-array-like ES3 and non-enumerable old V8 strings
    var indexedObject = fails$8(function () {
      // throws an error in rhino, see https://github.com/mozilla/rhino/issues/346
      // eslint-disable-next-line no-prototype-builtins -- safe
      return !$Object$3('z').propertyIsEnumerable(0);
    }) ? function (it) {
      return classof$4(it) === 'String' ? split(it, '') : $Object$3(it);
    } : $Object$3;

    // we can't use just `it == null` since of `document.all` special case
    // https://tc39.es/ecma262/#sec-IsHTMLDDA-internal-slot-aec
    var isNullOrUndefined$2 = function (it) {
      return it === null || it === undefined;
    };

    var isNullOrUndefined$1 = isNullOrUndefined$2;

    var $TypeError$8 = TypeError;

    // `RequireObjectCoercible` abstract operation
    // https://tc39.es/ecma262/#sec-requireobjectcoercible
    var requireObjectCoercible$2 = function (it) {
      if (isNullOrUndefined$1(it)) throw new $TypeError$8("Can't call method on " + it);
      return it;
    };

    // toObject with fallback for non-array-like ES3 strings
    var IndexedObject$1 = indexedObject;
    var requireObjectCoercible$1 = requireObjectCoercible$2;

    var toIndexedObject$2 = function (it) {
      return IndexedObject$1(requireObjectCoercible$1(it));
    };

    var isCallable$9 = isCallable$a;

    var isObject$6 = function (it) {
      return typeof it == 'object' ? it !== null : isCallable$9(it);
    };

    var path$4 = {};

    var path$3 = path$4;
    var global$9 = global$a;
    var isCallable$8 = isCallable$a;

    var aFunction = function (variable) {
      return isCallable$8(variable) ? variable : undefined;
    };

    var getBuiltIn$2 = function (namespace, method) {
      return arguments.length < 2 ? aFunction(path$3[namespace]) || aFunction(global$9[namespace])
        : path$3[namespace] && path$3[namespace][method] || global$9[namespace] && global$9[namespace][method];
    };

    var engineUserAgent = typeof navigator != 'undefined' && String(navigator.userAgent) || '';

    var global$8 = global$a;
    var userAgent = engineUserAgent;

    var process = global$8.process;
    var Deno = global$8.Deno;
    var versions = process && process.versions || Deno && Deno.version;
    var v8 = versions && versions.v8;
    var match, version;

    if (v8) {
      match = v8.split('.');
      // in old Chrome, versions of V8 isn't V8 = Chrome / 10
      // but their correct versions are not interesting for us
      version = match[0] > 0 && match[0] < 4 ? 1 : +(match[0] + match[1]);
    }

    // BrowserFS NodeJS `process` polyfill incorrectly set `.v8` to `0.0`
    // so check `userAgent` even if `.v8` exists, but 0
    if (!version && userAgent) {
      match = userAgent.match(/Edge\/(\d+)/);
      if (!match || match[1] >= 74) {
        match = userAgent.match(/Chrome\/(\d+)/);
        if (match) version = +match[1];
      }
    }

    var engineV8Version = version;

    /* eslint-disable es/no-symbol -- required for testing */
    var V8_VERSION$2 = engineV8Version;
    var fails$7 = fails$b;
    var global$7 = global$a;

    var $String$2 = global$7.String;

    // eslint-disable-next-line es/no-object-getownpropertysymbols -- required for testing
    var symbolConstructorDetection = !!Object.getOwnPropertySymbols && !fails$7(function () {
      var symbol = Symbol('symbol detection');
      // Chrome 38 Symbol has incorrect toString conversion
      // `get-own-property-symbols` polyfill symbols converted to object are not Symbol instances
      // nb: Do not call `String` directly to avoid this being optimized out to `symbol+''` which will,
      // of course, fail.
      return !$String$2(symbol) || !(Object(symbol) instanceof Symbol) ||
        // Chrome 38-40 symbols are not inherited from DOM collections prototypes to instances
        !Symbol.sham && V8_VERSION$2 && V8_VERSION$2 < 41;
    });

    /* eslint-disable es/no-symbol -- required for testing */
    var NATIVE_SYMBOL$1 = symbolConstructorDetection;

    var useSymbolAsUid = NATIVE_SYMBOL$1
      && !Symbol.sham
      && typeof Symbol.iterator == 'symbol';

    var getBuiltIn$1 = getBuiltIn$2;
    var isCallable$7 = isCallable$a;
    var isPrototypeOf$7 = objectIsPrototypeOf;
    var USE_SYMBOL_AS_UID$1 = useSymbolAsUid;

    var $Object$2 = Object;

    var isSymbol$2 = USE_SYMBOL_AS_UID$1 ? function (it) {
      return typeof it == 'symbol';
    } : function (it) {
      var $Symbol = getBuiltIn$1('Symbol');
      return isCallable$7($Symbol) && isPrototypeOf$7($Symbol.prototype, $Object$2(it));
    };

    var $String$1 = String;

    var tryToString$2 = function (argument) {
      try {
        return $String$1(argument);
      } catch (error) {
        return 'Object';
      }
    };

    var isCallable$6 = isCallable$a;
    var tryToString$1 = tryToString$2;

    var $TypeError$7 = TypeError;

    // `Assert: IsCallable(argument) is true`
    var aCallable$2 = function (argument) {
      if (isCallable$6(argument)) return argument;
      throw new $TypeError$7(tryToString$1(argument) + ' is not a function');
    };

    var aCallable$1 = aCallable$2;
    var isNullOrUndefined = isNullOrUndefined$2;

    // `GetMethod` abstract operation
    // https://tc39.es/ecma262/#sec-getmethod
    var getMethod$1 = function (V, P) {
      var func = V[P];
      return isNullOrUndefined(func) ? undefined : aCallable$1(func);
    };

    var call$2 = functionCall;
    var isCallable$5 = isCallable$a;
    var isObject$5 = isObject$6;

    var $TypeError$6 = TypeError;

    // `OrdinaryToPrimitive` abstract operation
    // https://tc39.es/ecma262/#sec-ordinarytoprimitive
    var ordinaryToPrimitive$1 = function (input, pref) {
      var fn, val;
      if (pref === 'string' && isCallable$5(fn = input.toString) && !isObject$5(val = call$2(fn, input))) return val;
      if (isCallable$5(fn = input.valueOf) && !isObject$5(val = call$2(fn, input))) return val;
      if (pref !== 'string' && isCallable$5(fn = input.toString) && !isObject$5(val = call$2(fn, input))) return val;
      throw new $TypeError$6("Can't convert object to primitive value");
    };

    var shared$1 = {exports: {}};

    var global$6 = global$a;

    // eslint-disable-next-line es/no-object-defineproperty -- safe
    var defineProperty = Object.defineProperty;

    var defineGlobalProperty$1 = function (key, value) {
      try {
        defineProperty(global$6, key, { value: value, configurable: true, writable: true });
      } catch (error) {
        global$6[key] = value;
      } return value;
    };

    var global$5 = global$a;
    var defineGlobalProperty = defineGlobalProperty$1;

    var SHARED = '__core-js_shared__';
    var store$2 = global$5[SHARED] || defineGlobalProperty(SHARED, {});

    var sharedStore = store$2;

    var store$1 = sharedStore;

    (shared$1.exports = function (key, value) {
      return store$1[key] || (store$1[key] = value !== undefined ? value : {});
    })('versions', []).push({
      version: '3.35.1',
      mode: 'pure' ,
      copyright: '© 2014-2024 Denis Pushkarev (zloirock.ru)',
      license: 'https://github.com/zloirock/core-js/blob/v3.35.1/LICENSE',
      source: 'https://github.com/zloirock/core-js'
    });

    var sharedExports = shared$1.exports;

    var requireObjectCoercible = requireObjectCoercible$2;

    var $Object$1 = Object;

    // `ToObject` abstract operation
    // https://tc39.es/ecma262/#sec-toobject
    var toObject$4 = function (argument) {
      return $Object$1(requireObjectCoercible(argument));
    };

    var uncurryThis$7 = functionUncurryThis;
    var toObject$3 = toObject$4;

    var hasOwnProperty = uncurryThis$7({}.hasOwnProperty);

    // `HasOwnProperty` abstract operation
    // https://tc39.es/ecma262/#sec-hasownproperty
    // eslint-disable-next-line es/no-object-hasown -- safe
    var hasOwnProperty_1 = Object.hasOwn || function hasOwn(it, key) {
      return hasOwnProperty(toObject$3(it), key);
    };

    var uncurryThis$6 = functionUncurryThis;

    var id = 0;
    var postfix = Math.random();
    var toString = uncurryThis$6(1.0.toString);

    var uid$1 = function (key) {
      return 'Symbol(' + (key === undefined ? '' : key) + ')_' + toString(++id + postfix, 36);
    };

    var global$4 = global$a;
    var shared = sharedExports;
    var hasOwn$3 = hasOwnProperty_1;
    var uid = uid$1;
    var NATIVE_SYMBOL = symbolConstructorDetection;
    var USE_SYMBOL_AS_UID = useSymbolAsUid;

    var Symbol$1 = global$4.Symbol;
    var WellKnownSymbolsStore = shared('wks');
    var createWellKnownSymbol = USE_SYMBOL_AS_UID ? Symbol$1['for'] || Symbol$1 : Symbol$1 && Symbol$1.withoutSetter || uid;

    var wellKnownSymbol$6 = function (name) {
      if (!hasOwn$3(WellKnownSymbolsStore, name)) {
        WellKnownSymbolsStore[name] = NATIVE_SYMBOL && hasOwn$3(Symbol$1, name)
          ? Symbol$1[name]
          : createWellKnownSymbol('Symbol.' + name);
      } return WellKnownSymbolsStore[name];
    };

    var call$1 = functionCall;
    var isObject$4 = isObject$6;
    var isSymbol$1 = isSymbol$2;
    var getMethod = getMethod$1;
    var ordinaryToPrimitive = ordinaryToPrimitive$1;
    var wellKnownSymbol$5 = wellKnownSymbol$6;

    var $TypeError$5 = TypeError;
    var TO_PRIMITIVE = wellKnownSymbol$5('toPrimitive');

    // `ToPrimitive` abstract operation
    // https://tc39.es/ecma262/#sec-toprimitive
    var toPrimitive$1 = function (input, pref) {
      if (!isObject$4(input) || isSymbol$1(input)) return input;
      var exoticToPrim = getMethod(input, TO_PRIMITIVE);
      var result;
      if (exoticToPrim) {
        if (pref === undefined) pref = 'default';
        result = call$1(exoticToPrim, input, pref);
        if (!isObject$4(result) || isSymbol$1(result)) return result;
        throw new $TypeError$5("Can't convert object to primitive value");
      }
      if (pref === undefined) pref = 'number';
      return ordinaryToPrimitive(input, pref);
    };

    var toPrimitive = toPrimitive$1;
    var isSymbol = isSymbol$2;

    // `ToPropertyKey` abstract operation
    // https://tc39.es/ecma262/#sec-topropertykey
    var toPropertyKey$3 = function (argument) {
      var key = toPrimitive(argument, 'string');
      return isSymbol(key) ? key : key + '';
    };

    var global$3 = global$a;
    var isObject$3 = isObject$6;

    var document$1 = global$3.document;
    // typeof document.createElement is 'object' in old IE
    var EXISTS = isObject$3(document$1) && isObject$3(document$1.createElement);

    var documentCreateElement = function (it) {
      return EXISTS ? document$1.createElement(it) : {};
    };

    var DESCRIPTORS$5 = descriptors;
    var fails$6 = fails$b;
    var createElement = documentCreateElement;

    // Thanks to IE8 for its funny defineProperty
    var ie8DomDefine = !DESCRIPTORS$5 && !fails$6(function () {
      // eslint-disable-next-line es/no-object-defineproperty -- required for testing
      return Object.defineProperty(createElement('div'), 'a', {
        get: function () { return 7; }
      }).a !== 7;
    });

    var DESCRIPTORS$4 = descriptors;
    var call = functionCall;
    var propertyIsEnumerableModule = objectPropertyIsEnumerable;
    var createPropertyDescriptor$2 = createPropertyDescriptor$3;
    var toIndexedObject$1 = toIndexedObject$2;
    var toPropertyKey$2 = toPropertyKey$3;
    var hasOwn$2 = hasOwnProperty_1;
    var IE8_DOM_DEFINE$1 = ie8DomDefine;

    // eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
    var $getOwnPropertyDescriptor$1 = Object.getOwnPropertyDescriptor;

    // `Object.getOwnPropertyDescriptor` method
    // https://tc39.es/ecma262/#sec-object.getownpropertydescriptor
    objectGetOwnPropertyDescriptor.f = DESCRIPTORS$4 ? $getOwnPropertyDescriptor$1 : function getOwnPropertyDescriptor(O, P) {
      O = toIndexedObject$1(O);
      P = toPropertyKey$2(P);
      if (IE8_DOM_DEFINE$1) try {
        return $getOwnPropertyDescriptor$1(O, P);
      } catch (error) { /* empty */ }
      if (hasOwn$2(O, P)) return createPropertyDescriptor$2(!call(propertyIsEnumerableModule.f, O, P), O[P]);
    };

    var fails$5 = fails$b;
    var isCallable$4 = isCallable$a;

    var replacement = /#|\.prototype\./;

    var isForced$1 = function (feature, detection) {
      var value = data[normalize(feature)];
      return value === POLYFILL ? true
        : value === NATIVE ? false
        : isCallable$4(detection) ? fails$5(detection)
        : !!detection;
    };

    var normalize = isForced$1.normalize = function (string) {
      return String(string).replace(replacement, '.').toLowerCase();
    };

    var data = isForced$1.data = {};
    var NATIVE = isForced$1.NATIVE = 'N';
    var POLYFILL = isForced$1.POLYFILL = 'P';

    var isForced_1 = isForced$1;

    var uncurryThis$5 = functionUncurryThisClause;
    var aCallable = aCallable$2;
    var NATIVE_BIND = functionBindNative;

    var bind$2 = uncurryThis$5(uncurryThis$5.bind);

    // optional / simple context binding
    var functionBindContext = function (fn, that) {
      aCallable(fn);
      return that === undefined ? fn : NATIVE_BIND ? bind$2(fn, that) : function (/* ...args */) {
        return fn.apply(that, arguments);
      };
    };

    var objectDefineProperty = {};

    var DESCRIPTORS$3 = descriptors;
    var fails$4 = fails$b;

    // V8 ~ Chrome 36-
    // https://bugs.chromium.org/p/v8/issues/detail?id=3334
    var v8PrototypeDefineBug = DESCRIPTORS$3 && fails$4(function () {
      // eslint-disable-next-line es/no-object-defineproperty -- required for testing
      return Object.defineProperty(function () { /* empty */ }, 'prototype', {
        value: 42,
        writable: false
      }).prototype !== 42;
    });

    var isObject$2 = isObject$6;

    var $String = String;
    var $TypeError$4 = TypeError;

    // `Assert: Type(argument) is Object`
    var anObject$1 = function (argument) {
      if (isObject$2(argument)) return argument;
      throw new $TypeError$4($String(argument) + ' is not an object');
    };

    var DESCRIPTORS$2 = descriptors;
    var IE8_DOM_DEFINE = ie8DomDefine;
    var V8_PROTOTYPE_DEFINE_BUG = v8PrototypeDefineBug;
    var anObject = anObject$1;
    var toPropertyKey$1 = toPropertyKey$3;

    var $TypeError$3 = TypeError;
    // eslint-disable-next-line es/no-object-defineproperty -- safe
    var $defineProperty = Object.defineProperty;
    // eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
    var $getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
    var ENUMERABLE = 'enumerable';
    var CONFIGURABLE = 'configurable';
    var WRITABLE = 'writable';

    // `Object.defineProperty` method
    // https://tc39.es/ecma262/#sec-object.defineproperty
    objectDefineProperty.f = DESCRIPTORS$2 ? V8_PROTOTYPE_DEFINE_BUG ? function defineProperty(O, P, Attributes) {
      anObject(O);
      P = toPropertyKey$1(P);
      anObject(Attributes);
      if (typeof O === 'function' && P === 'prototype' && 'value' in Attributes && WRITABLE in Attributes && !Attributes[WRITABLE]) {
        var current = $getOwnPropertyDescriptor(O, P);
        if (current && current[WRITABLE]) {
          O[P] = Attributes.value;
          Attributes = {
            configurable: CONFIGURABLE in Attributes ? Attributes[CONFIGURABLE] : current[CONFIGURABLE],
            enumerable: ENUMERABLE in Attributes ? Attributes[ENUMERABLE] : current[ENUMERABLE],
            writable: false
          };
        }
      } return $defineProperty(O, P, Attributes);
    } : $defineProperty : function defineProperty(O, P, Attributes) {
      anObject(O);
      P = toPropertyKey$1(P);
      anObject(Attributes);
      if (IE8_DOM_DEFINE) try {
        return $defineProperty(O, P, Attributes);
      } catch (error) { /* empty */ }
      if ('get' in Attributes || 'set' in Attributes) throw new $TypeError$3('Accessors not supported');
      if ('value' in Attributes) O[P] = Attributes.value;
      return O;
    };

    var DESCRIPTORS$1 = descriptors;
    var definePropertyModule$1 = objectDefineProperty;
    var createPropertyDescriptor$1 = createPropertyDescriptor$3;

    var createNonEnumerableProperty$1 = DESCRIPTORS$1 ? function (object, key, value) {
      return definePropertyModule$1.f(object, key, createPropertyDescriptor$1(1, value));
    } : function (object, key, value) {
      object[key] = value;
      return object;
    };

    var global$2 = global$a;
    var apply = functionApply;
    var uncurryThis$4 = functionUncurryThisClause;
    var isCallable$3 = isCallable$a;
    var getOwnPropertyDescriptor$1 = objectGetOwnPropertyDescriptor.f;
    var isForced = isForced_1;
    var path$2 = path$4;
    var bind$1 = functionBindContext;
    var createNonEnumerableProperty = createNonEnumerableProperty$1;
    var hasOwn$1 = hasOwnProperty_1;

    var wrapConstructor = function (NativeConstructor) {
      var Wrapper = function (a, b, c) {
        if (this instanceof Wrapper) {
          switch (arguments.length) {
            case 0: return new NativeConstructor();
            case 1: return new NativeConstructor(a);
            case 2: return new NativeConstructor(a, b);
          } return new NativeConstructor(a, b, c);
        } return apply(NativeConstructor, this, arguments);
      };
      Wrapper.prototype = NativeConstructor.prototype;
      return Wrapper;
    };

    /*
      options.target         - name of the target object
      options.global         - target is the global object
      options.stat           - export as static methods of target
      options.proto          - export as prototype methods of target
      options.real           - real prototype method for the `pure` version
      options.forced         - export even if the native feature is available
      options.bind           - bind methods to the target, required for the `pure` version
      options.wrap           - wrap constructors to preventing global pollution, required for the `pure` version
      options.unsafe         - use the simple assignment of property instead of delete + defineProperty
      options.sham           - add a flag to not completely full polyfills
      options.enumerable     - export as enumerable property
      options.dontCallGetSet - prevent calling a getter on target
      options.name           - the .name of the function if it does not match the key
    */
    var _export = function (options, source) {
      var TARGET = options.target;
      var GLOBAL = options.global;
      var STATIC = options.stat;
      var PROTO = options.proto;

      var nativeSource = GLOBAL ? global$2 : STATIC ? global$2[TARGET] : global$2[TARGET] && global$2[TARGET].prototype;

      var target = GLOBAL ? path$2 : path$2[TARGET] || createNonEnumerableProperty(path$2, TARGET, {})[TARGET];
      var targetPrototype = target.prototype;

      var FORCED, USE_NATIVE, VIRTUAL_PROTOTYPE;
      var key, sourceProperty, targetProperty, nativeProperty, resultProperty, descriptor;

      for (key in source) {
        FORCED = isForced(GLOBAL ? key : TARGET + (STATIC ? '.' : '#') + key, options.forced);
        // contains in native
        USE_NATIVE = !FORCED && nativeSource && hasOwn$1(nativeSource, key);

        targetProperty = target[key];

        if (USE_NATIVE) if (options.dontCallGetSet) {
          descriptor = getOwnPropertyDescriptor$1(nativeSource, key);
          nativeProperty = descriptor && descriptor.value;
        } else nativeProperty = nativeSource[key];

        // export native or implementation
        sourceProperty = (USE_NATIVE && nativeProperty) ? nativeProperty : source[key];

        if (!FORCED && !PROTO && typeof targetProperty == typeof sourceProperty) continue;

        // bind methods to global for calling from export context
        if (options.bind && USE_NATIVE) resultProperty = bind$1(sourceProperty, global$2);
        // wrap global constructors for prevent changes in this version
        else if (options.wrap && USE_NATIVE) resultProperty = wrapConstructor(sourceProperty);
        // make static versions for prototype methods
        else if (PROTO && isCallable$3(sourceProperty)) resultProperty = uncurryThis$4(sourceProperty);
        // default case
        else resultProperty = sourceProperty;

        // add a flag to not completely full polyfills
        if (options.sham || (sourceProperty && sourceProperty.sham) || (targetProperty && targetProperty.sham)) {
          createNonEnumerableProperty(resultProperty, 'sham', true);
        }

        createNonEnumerableProperty(target, key, resultProperty);

        if (PROTO) {
          VIRTUAL_PROTOTYPE = TARGET + 'Prototype';
          if (!hasOwn$1(path$2, VIRTUAL_PROTOTYPE)) {
            createNonEnumerableProperty(path$2, VIRTUAL_PROTOTYPE, {});
          }
          // export virtual prototype methods
          createNonEnumerableProperty(path$2[VIRTUAL_PROTOTYPE], key, sourceProperty);
          // export real prototype methods
          if (options.real && targetPrototype && (FORCED || !targetPrototype[key])) {
            createNonEnumerableProperty(targetPrototype, key, sourceProperty);
          }
        }
      }
    };

    var ceil = Math.ceil;
    var floor = Math.floor;

    // `Math.trunc` method
    // https://tc39.es/ecma262/#sec-math.trunc
    // eslint-disable-next-line es/no-math-trunc -- safe
    var mathTrunc = Math.trunc || function trunc(x) {
      var n = +x;
      return (n > 0 ? floor : ceil)(n);
    };

    var trunc = mathTrunc;

    // `ToIntegerOrInfinity` abstract operation
    // https://tc39.es/ecma262/#sec-tointegerorinfinity
    var toIntegerOrInfinity$3 = function (argument) {
      var number = +argument;
      // eslint-disable-next-line no-self-compare -- NaN check
      return number !== number || number === 0 ? 0 : trunc(number);
    };

    var toIntegerOrInfinity$2 = toIntegerOrInfinity$3;

    var min$2 = Math.min;

    // `ToLength` abstract operation
    // https://tc39.es/ecma262/#sec-tolength
    var toLength$1 = function (argument) {
      var len = toIntegerOrInfinity$2(argument);
      return len > 0 ? min$2(len, 0x1FFFFFFFFFFFFF) : 0; // 2 ** 53 - 1 == 9007199254740991
    };

    var toLength = toLength$1;

    // `LengthOfArrayLike` abstract operation
    // https://tc39.es/ecma262/#sec-lengthofarraylike
    var lengthOfArrayLike$4 = function (obj) {
      return toLength(obj.length);
    };

    var classof$3 = classofRaw$2;

    // `IsArray` abstract operation
    // https://tc39.es/ecma262/#sec-isarray
    // eslint-disable-next-line es/no-array-isarray -- safe
    var isArray$a = Array.isArray || function isArray(argument) {
      return classof$3(argument) === 'Array';
    };

    var wellKnownSymbol$4 = wellKnownSymbol$6;

    var TO_STRING_TAG$1 = wellKnownSymbol$4('toStringTag');
    var test = {};

    test[TO_STRING_TAG$1] = 'z';

    var toStringTagSupport = String(test) === '[object z]';

    var TO_STRING_TAG_SUPPORT = toStringTagSupport;
    var isCallable$2 = isCallable$a;
    var classofRaw = classofRaw$2;
    var wellKnownSymbol$3 = wellKnownSymbol$6;

    var TO_STRING_TAG = wellKnownSymbol$3('toStringTag');
    var $Object = Object;

    // ES3 wrong here
    var CORRECT_ARGUMENTS = classofRaw(function () { return arguments; }()) === 'Arguments';

    // fallback for IE11 Script Access Denied error
    var tryGet = function (it, key) {
      try {
        return it[key];
      } catch (error) { /* empty */ }
    };

    // getting tag from ES6+ `Object.prototype.toString`
    var classof$2 = TO_STRING_TAG_SUPPORT ? classofRaw : function (it) {
      var O, tag, result;
      return it === undefined ? 'Undefined' : it === null ? 'Null'
        // @@toStringTag case
        : typeof (tag = tryGet(O = $Object(it), TO_STRING_TAG)) == 'string' ? tag
        // builtinTag case
        : CORRECT_ARGUMENTS ? classofRaw(O)
        // ES3 arguments fallback
        : (result = classofRaw(O)) === 'Object' && isCallable$2(O.callee) ? 'Arguments' : result;
    };

    var uncurryThis$3 = functionUncurryThis;
    var isCallable$1 = isCallable$a;
    var store = sharedStore;

    var functionToString = uncurryThis$3(Function.toString);

    // this helper broken in `core-js@3.4.1-3.4.4`, so we can't use `shared` helper
    if (!isCallable$1(store.inspectSource)) {
      store.inspectSource = function (it) {
        return functionToString(it);
      };
    }

    var inspectSource$1 = store.inspectSource;

    var uncurryThis$2 = functionUncurryThis;
    var fails$3 = fails$b;
    var isCallable = isCallable$a;
    var classof$1 = classof$2;
    var getBuiltIn = getBuiltIn$2;
    var inspectSource = inspectSource$1;

    var noop = function () { /* empty */ };
    var construct = getBuiltIn('Reflect', 'construct');
    var constructorRegExp = /^\s*(?:class|function)\b/;
    var exec = uncurryThis$2(constructorRegExp.exec);
    var INCORRECT_TO_STRING = !constructorRegExp.test(noop);

    var isConstructorModern = function isConstructor(argument) {
      if (!isCallable(argument)) return false;
      try {
        construct(noop, [], argument);
        return true;
      } catch (error) {
        return false;
      }
    };

    var isConstructorLegacy = function isConstructor(argument) {
      if (!isCallable(argument)) return false;
      switch (classof$1(argument)) {
        case 'AsyncFunction':
        case 'GeneratorFunction':
        case 'AsyncGeneratorFunction': return false;
      }
      try {
        // we can't check .prototype since constructors produced by .bind haven't it
        // `Function#toString` throws on some built-it function in some legacy engines
        // (for example, `DOMQuad` and similar in FF41-)
        return INCORRECT_TO_STRING || !!exec(constructorRegExp, inspectSource(argument));
      } catch (error) {
        return true;
      }
    };

    isConstructorLegacy.sham = true;

    // `IsConstructor` abstract operation
    // https://tc39.es/ecma262/#sec-isconstructor
    var isConstructor$1 = !construct || fails$3(function () {
      var called;
      return isConstructorModern(isConstructorModern.call)
        || !isConstructorModern(Object)
        || !isConstructorModern(function () { called = true; })
        || called;
    }) ? isConstructorLegacy : isConstructorModern;

    var isArray$9 = isArray$a;
    var isConstructor = isConstructor$1;
    var isObject$1 = isObject$6;
    var wellKnownSymbol$2 = wellKnownSymbol$6;

    var SPECIES$1 = wellKnownSymbol$2('species');
    var $Array = Array;

    // a part of `ArraySpeciesCreate` abstract operation
    // https://tc39.es/ecma262/#sec-arrayspeciescreate
    var arraySpeciesConstructor$1 = function (originalArray) {
      var C;
      if (isArray$9(originalArray)) {
        C = originalArray.constructor;
        // cross-realm fallback
        if (isConstructor(C) && (C === $Array || isArray$9(C.prototype))) C = undefined;
        else if (isObject$1(C)) {
          C = C[SPECIES$1];
          if (C === null) C = undefined;
        }
      } return C === undefined ? $Array : C;
    };

    var arraySpeciesConstructor = arraySpeciesConstructor$1;

    // `ArraySpeciesCreate` abstract operation
    // https://tc39.es/ecma262/#sec-arrayspeciescreate
    var arraySpeciesCreate$3 = function (originalArray, length) {
      return new (arraySpeciesConstructor(originalArray))(length === 0 ? 0 : length);
    };

    var bind = functionBindContext;
    var uncurryThis$1 = functionUncurryThis;
    var IndexedObject = indexedObject;
    var toObject$2 = toObject$4;
    var lengthOfArrayLike$3 = lengthOfArrayLike$4;
    var arraySpeciesCreate$2 = arraySpeciesCreate$3;

    var push = uncurryThis$1([].push);

    // `Array.prototype.{ forEach, map, filter, some, every, find, findIndex, filterReject }` methods implementation
    var createMethod$1 = function (TYPE) {
      var IS_MAP = TYPE === 1;
      var IS_FILTER = TYPE === 2;
      var IS_SOME = TYPE === 3;
      var IS_EVERY = TYPE === 4;
      var IS_FIND_INDEX = TYPE === 6;
      var IS_FILTER_REJECT = TYPE === 7;
      var NO_HOLES = TYPE === 5 || IS_FIND_INDEX;
      return function ($this, callbackfn, that, specificCreate) {
        var O = toObject$2($this);
        var self = IndexedObject(O);
        var length = lengthOfArrayLike$3(self);
        var boundFunction = bind(callbackfn, that);
        var index = 0;
        var create = specificCreate || arraySpeciesCreate$2;
        var target = IS_MAP ? create($this, length) : IS_FILTER || IS_FILTER_REJECT ? create($this, 0) : undefined;
        var value, result;
        for (;length > index; index++) if (NO_HOLES || index in self) {
          value = self[index];
          result = boundFunction(value, index, O);
          if (TYPE) {
            if (IS_MAP) target[index] = result; // map
            else if (result) switch (TYPE) {
              case 3: return true;              // some
              case 5: return value;             // find
              case 6: return index;             // findIndex
              case 2: push(target, value);      // filter
            } else switch (TYPE) {
              case 4: return false;             // every
              case 7: push(target, value);      // filterReject
            }
          }
        }
        return IS_FIND_INDEX ? -1 : IS_SOME || IS_EVERY ? IS_EVERY : target;
      };
    };

    var arrayIteration = {
      // `Array.prototype.forEach` method
      // https://tc39.es/ecma262/#sec-array.prototype.foreach
      forEach: createMethod$1(0),
      // `Array.prototype.map` method
      // https://tc39.es/ecma262/#sec-array.prototype.map
      map: createMethod$1(1),
      // `Array.prototype.filter` method
      // https://tc39.es/ecma262/#sec-array.prototype.filter
      filter: createMethod$1(2),
      // `Array.prototype.some` method
      // https://tc39.es/ecma262/#sec-array.prototype.some
      some: createMethod$1(3),
      // `Array.prototype.every` method
      // https://tc39.es/ecma262/#sec-array.prototype.every
      every: createMethod$1(4),
      // `Array.prototype.find` method
      // https://tc39.es/ecma262/#sec-array.prototype.find
      find: createMethod$1(5),
      // `Array.prototype.findIndex` method
      // https://tc39.es/ecma262/#sec-array.prototype.findIndex
      findIndex: createMethod$1(6),
      // `Array.prototype.filterReject` method
      // https://github.com/tc39/proposal-array-filtering
      filterReject: createMethod$1(7)
    };

    var fails$2 = fails$b;
    var wellKnownSymbol$1 = wellKnownSymbol$6;
    var V8_VERSION$1 = engineV8Version;

    var SPECIES = wellKnownSymbol$1('species');

    var arrayMethodHasSpeciesSupport$3 = function (METHOD_NAME) {
      // We can't use this feature detection in V8 since it causes
      // deoptimization and serious performance degradation
      // https://github.com/zloirock/core-js/issues/677
      return V8_VERSION$1 >= 51 || !fails$2(function () {
        var array = [];
        var constructor = array.constructor = {};
        constructor[SPECIES] = function () {
          return { foo: 1 };
        };
        return array[METHOD_NAME](Boolean).foo !== 1;
      });
    };

    var $$7 = _export;
    var $map = arrayIteration.map;
    var arrayMethodHasSpeciesSupport$2 = arrayMethodHasSpeciesSupport$3;

    var HAS_SPECIES_SUPPORT$1 = arrayMethodHasSpeciesSupport$2('map');

    // `Array.prototype.map` method
    // https://tc39.es/ecma262/#sec-array.prototype.map
    // with adding support of @@species
    $$7({ target: 'Array', proto: true, forced: !HAS_SPECIES_SUPPORT$1 }, {
      map: function map(callbackfn /* , thisArg */) {
        return $map(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
      }
    });

    var global$1 = global$a;
    var path$1 = path$4;

    var getBuiltInPrototypeMethod$7 = function (CONSTRUCTOR, METHOD) {
      var Namespace = path$1[CONSTRUCTOR + 'Prototype'];
      var pureMethod = Namespace && Namespace[METHOD];
      if (pureMethod) return pureMethod;
      var NativeConstructor = global$1[CONSTRUCTOR];
      var NativePrototype = NativeConstructor && NativeConstructor.prototype;
      return NativePrototype && NativePrototype[METHOD];
    };

    var getBuiltInPrototypeMethod$6 = getBuiltInPrototypeMethod$7;

    var map$6 = getBuiltInPrototypeMethod$6('Array', 'map');

    var isPrototypeOf$6 = objectIsPrototypeOf;
    var method$6 = map$6;

    var ArrayPrototype$6 = Array.prototype;

    var map$5 = function (it) {
      var own = it.map;
      return it === ArrayPrototype$6 || (isPrototypeOf$6(ArrayPrototype$6, it) && own === ArrayPrototype$6.map) ? method$6 : own;
    };

    var parent$n = map$5;

    var map$4 = parent$n;

    var parent$m = map$4;

    var map$3 = parent$m;

    var parent$l = map$3;

    var map$2 = parent$l;

    var map$1 = map$2;

    var map = map$1;

    var _mapInstanceProperty = /*@__PURE__*/getDefaultExportFromCjs(map);

    var AuxiliaryType;
    (function (AuxiliaryType) {
      AuxiliaryType[AuxiliaryType["Null"] = 0] = "Null";
      AuxiliaryType[AuxiliaryType["Only"] = 1] = "Only";
      AuxiliaryType[AuxiliaryType["Head"] = 2] = "Head";
      AuxiliaryType[AuxiliaryType["Mid"] = 3] = "Mid";
      AuxiliaryType[AuxiliaryType["Last"] = 4] = "Last";
    })(AuxiliaryType || (AuxiliaryType = {}));

    var $$6 = _export;
    var $find = arrayIteration.find;

    var FIND = 'find';
    var SKIPS_HOLES$1 = true;

    // Shouldn't skip holes
    // eslint-disable-next-line es/no-array-prototype-find -- testing
    if (FIND in []) Array(1)[FIND](function () { SKIPS_HOLES$1 = false; });

    // `Array.prototype.find` method
    // https://tc39.es/ecma262/#sec-array.prototype.find
    $$6({ target: 'Array', proto: true, forced: SKIPS_HOLES$1 }, {
      find: function find(callbackfn /* , that = undefined */) {
        return $find(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
      }
    });

    var getBuiltInPrototypeMethod$5 = getBuiltInPrototypeMethod$7;

    var find$6 = getBuiltInPrototypeMethod$5('Array', 'find');

    var isPrototypeOf$5 = objectIsPrototypeOf;
    var method$5 = find$6;

    var ArrayPrototype$5 = Array.prototype;

    var find$5 = function (it) {
      var own = it.find;
      return it === ArrayPrototype$5 || (isPrototypeOf$5(ArrayPrototype$5, it) && own === ArrayPrototype$5.find) ? method$5 : own;
    };

    var parent$k = find$5;

    var find$4 = parent$k;

    var parent$j = find$4;

    var find$3 = parent$j;

    var parent$i = find$3;

    var find$2 = parent$i;

    var find$1 = find$2;

    var find = find$1;

    var _findInstanceProperty = /*@__PURE__*/getDefaultExportFromCjs(find);

    var $$5 = _export;
    var $findIndex = arrayIteration.findIndex;

    var FIND_INDEX = 'findIndex';
    var SKIPS_HOLES = true;

    // Shouldn't skip holes
    // eslint-disable-next-line es/no-array-prototype-findindex -- testing
    if (FIND_INDEX in []) Array(1)[FIND_INDEX](function () { SKIPS_HOLES = false; });

    // `Array.prototype.findIndex` method
    // https://tc39.es/ecma262/#sec-array.prototype.findindex
    $$5({ target: 'Array', proto: true, forced: SKIPS_HOLES }, {
      findIndex: function findIndex(callbackfn /* , that = undefined */) {
        return $findIndex(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
      }
    });

    var getBuiltInPrototypeMethod$4 = getBuiltInPrototypeMethod$7;

    var findIndex$6 = getBuiltInPrototypeMethod$4('Array', 'findIndex');

    var isPrototypeOf$4 = objectIsPrototypeOf;
    var method$4 = findIndex$6;

    var ArrayPrototype$4 = Array.prototype;

    var findIndex$5 = function (it) {
      var own = it.findIndex;
      return it === ArrayPrototype$4 || (isPrototypeOf$4(ArrayPrototype$4, it) && own === ArrayPrototype$4.findIndex) ? method$4 : own;
    };

    var parent$h = findIndex$5;

    var findIndex$4 = parent$h;

    var parent$g = findIndex$4;

    var findIndex$3 = parent$g;

    var parent$f = findIndex$3;

    var findIndex$2 = parent$f;

    var findIndex$1 = findIndex$2;

    var findIndex = findIndex$1;

    var _findIndexInstanceProperty = /*@__PURE__*/getDefaultExportFromCjs(findIndex);

    var $TypeError$2 = TypeError;
    var MAX_SAFE_INTEGER = 0x1FFFFFFFFFFFFF; // 2 ** 53 - 1 == 9007199254740991

    var doesNotExceedSafeInteger$2 = function (it) {
      if (it > MAX_SAFE_INTEGER) throw $TypeError$2('Maximum allowed index exceeded');
      return it;
    };

    var toPropertyKey = toPropertyKey$3;
    var definePropertyModule = objectDefineProperty;
    var createPropertyDescriptor = createPropertyDescriptor$3;

    var createProperty$2 = function (object, key, value) {
      var propertyKey = toPropertyKey(key);
      if (propertyKey in object) definePropertyModule.f(object, propertyKey, createPropertyDescriptor(0, value));
      else object[propertyKey] = value;
    };

    var $$4 = _export;
    var fails$1 = fails$b;
    var isArray$8 = isArray$a;
    var isObject = isObject$6;
    var toObject$1 = toObject$4;
    var lengthOfArrayLike$2 = lengthOfArrayLike$4;
    var doesNotExceedSafeInteger$1 = doesNotExceedSafeInteger$2;
    var createProperty$1 = createProperty$2;
    var arraySpeciesCreate$1 = arraySpeciesCreate$3;
    var arrayMethodHasSpeciesSupport$1 = arrayMethodHasSpeciesSupport$3;
    var wellKnownSymbol = wellKnownSymbol$6;
    var V8_VERSION = engineV8Version;

    var IS_CONCAT_SPREADABLE = wellKnownSymbol('isConcatSpreadable');

    // We can't use this feature detection in V8 since it causes
    // deoptimization and serious performance degradation
    // https://github.com/zloirock/core-js/issues/679
    var IS_CONCAT_SPREADABLE_SUPPORT = V8_VERSION >= 51 || !fails$1(function () {
      var array = [];
      array[IS_CONCAT_SPREADABLE] = false;
      return array.concat()[0] !== array;
    });

    var isConcatSpreadable = function (O) {
      if (!isObject(O)) return false;
      var spreadable = O[IS_CONCAT_SPREADABLE];
      return spreadable !== undefined ? !!spreadable : isArray$8(O);
    };

    var FORCED$1 = !IS_CONCAT_SPREADABLE_SUPPORT || !arrayMethodHasSpeciesSupport$1('concat');

    // `Array.prototype.concat` method
    // https://tc39.es/ecma262/#sec-array.prototype.concat
    // with adding support of @@isConcatSpreadable and @@species
    $$4({ target: 'Array', proto: true, arity: 1, forced: FORCED$1 }, {
      // eslint-disable-next-line no-unused-vars -- required for `.length`
      concat: function concat(arg) {
        var O = toObject$1(this);
        var A = arraySpeciesCreate$1(O, 0);
        var n = 0;
        var i, k, length, len, E;
        for (i = -1, length = arguments.length; i < length; i++) {
          E = i === -1 ? O : arguments[i];
          if (isConcatSpreadable(E)) {
            len = lengthOfArrayLike$2(E);
            doesNotExceedSafeInteger$1(n + len);
            for (k = 0; k < len; k++, n++) if (k in E) createProperty$1(A, n, E[k]);
          } else {
            doesNotExceedSafeInteger$1(n + 1);
            createProperty$1(A, n++, E);
          }
        }
        A.length = n;
        return A;
      }
    });

    var getBuiltInPrototypeMethod$3 = getBuiltInPrototypeMethod$7;

    var concat$6 = getBuiltInPrototypeMethod$3('Array', 'concat');

    var isPrototypeOf$3 = objectIsPrototypeOf;
    var method$3 = concat$6;

    var ArrayPrototype$3 = Array.prototype;

    var concat$5 = function (it) {
      var own = it.concat;
      return it === ArrayPrototype$3 || (isPrototypeOf$3(ArrayPrototype$3, it) && own === ArrayPrototype$3.concat) ? method$3 : own;
    };

    var parent$e = concat$5;

    var concat$4 = parent$e;

    var parent$d = concat$4;

    var concat$3 = parent$d;

    var parent$c = concat$3;

    var concat$2 = parent$c;

    var concat$1 = concat$2;

    var concat = concat$1;

    var _concatInstanceProperty = /*@__PURE__*/getDefaultExportFromCjs(concat);

    var toIntegerOrInfinity$1 = toIntegerOrInfinity$3;

    var max$1 = Math.max;
    var min$1 = Math.min;

    // Helper for a popular repeating case of the spec:
    // Let integer be ? ToInteger(index).
    // If integer < 0, let result be max((length + integer), 0); else let result be min(integer, length).
    var toAbsoluteIndex$2 = function (index, length) {
      var integer = toIntegerOrInfinity$1(index);
      return integer < 0 ? max$1(integer + length, 0) : min$1(integer, length);
    };

    var toIndexedObject = toIndexedObject$2;
    var toAbsoluteIndex$1 = toAbsoluteIndex$2;
    var lengthOfArrayLike$1 = lengthOfArrayLike$4;

    // `Array.prototype.{ indexOf, includes }` methods implementation
    var createMethod = function (IS_INCLUDES) {
      return function ($this, el, fromIndex) {
        var O = toIndexedObject($this);
        var length = lengthOfArrayLike$1(O);
        var index = toAbsoluteIndex$1(fromIndex, length);
        var value;
        // Array#includes uses SameValueZero equality algorithm
        // eslint-disable-next-line no-self-compare -- NaN check
        if (IS_INCLUDES && el !== el) while (length > index) {
          value = O[index++];
          // eslint-disable-next-line no-self-compare -- NaN check
          if (value !== value) return true;
        // Array#indexOf ignores holes, Array#includes - not
        } else for (;length > index; index++) {
          if ((IS_INCLUDES || index in O) && O[index] === el) return IS_INCLUDES || index || 0;
        } return !IS_INCLUDES && -1;
      };
    };

    var arrayIncludes = {
      // `Array.prototype.includes` method
      // https://tc39.es/ecma262/#sec-array.prototype.includes
      includes: createMethod(true),
      // `Array.prototype.indexOf` method
      // https://tc39.es/ecma262/#sec-array.prototype.indexof
      indexOf: createMethod(false)
    };

    var fails = fails$b;

    var arrayMethodIsStrict$2 = function (METHOD_NAME, argument) {
      var method = [][METHOD_NAME];
      return !!method && fails(function () {
        // eslint-disable-next-line no-useless-call -- required for testing
        method.call(null, argument || function () { return 1; }, 1);
      });
    };

    /* eslint-disable es/no-array-prototype-indexof -- required for testing */
    var $$3 = _export;
    var uncurryThis = functionUncurryThisClause;
    var $indexOf = arrayIncludes.indexOf;
    var arrayMethodIsStrict$1 = arrayMethodIsStrict$2;

    var nativeIndexOf = uncurryThis([].indexOf);

    var NEGATIVE_ZERO = !!nativeIndexOf && 1 / nativeIndexOf([1], 1, -0) < 0;
    var FORCED = NEGATIVE_ZERO || !arrayMethodIsStrict$1('indexOf');

    // `Array.prototype.indexOf` method
    // https://tc39.es/ecma262/#sec-array.prototype.indexof
    $$3({ target: 'Array', proto: true, forced: FORCED }, {
      indexOf: function indexOf(searchElement /* , fromIndex = 0 */) {
        var fromIndex = arguments.length > 1 ? arguments[1] : undefined;
        return NEGATIVE_ZERO
          // convert -0 to +0
          ? nativeIndexOf(this, searchElement, fromIndex) || 0
          : $indexOf(this, searchElement, fromIndex);
      }
    });

    var getBuiltInPrototypeMethod$2 = getBuiltInPrototypeMethod$7;

    var indexOf$6 = getBuiltInPrototypeMethod$2('Array', 'indexOf');

    var isPrototypeOf$2 = objectIsPrototypeOf;
    var method$2 = indexOf$6;

    var ArrayPrototype$2 = Array.prototype;

    var indexOf$5 = function (it) {
      var own = it.indexOf;
      return it === ArrayPrototype$2 || (isPrototypeOf$2(ArrayPrototype$2, it) && own === ArrayPrototype$2.indexOf) ? method$2 : own;
    };

    var parent$b = indexOf$5;

    var indexOf$4 = parent$b;

    var parent$a = indexOf$4;

    var indexOf$3 = parent$a;

    var parent$9 = indexOf$3;

    var indexOf$2 = parent$9;

    var indexOf$1 = indexOf$2;

    var indexOf = indexOf$1;

    var _indexOfInstanceProperty = /*@__PURE__*/getDefaultExportFromCjs(indexOf);

    var $$2 = _export;
    var isArray$7 = isArray$a;

    // `Array.isArray` method
    // https://tc39.es/ecma262/#sec-array.isarray
    $$2({ target: 'Array', stat: true }, {
      isArray: isArray$7
    });

    var path = path$4;

    var isArray$6 = path.Array.isArray;

    var parent$8 = isArray$6;

    var isArray$5 = parent$8;

    var parent$7 = isArray$5;

    var isArray$4 = parent$7;

    var parent$6 = isArray$4;

    var isArray$3 = parent$6;

    var isArray$2 = isArray$3;

    var isArray$1 = isArray$2;

    var _Array$isArray = /*@__PURE__*/getDefaultExportFromCjs(isArray$1);

    var DESCRIPTORS = descriptors;
    var isArray = isArray$a;

    var $TypeError$1 = TypeError;
    // eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
    var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;

    // Safari < 13 does not throw an error in this case
    var SILENT_ON_NON_WRITABLE_LENGTH_SET = DESCRIPTORS && !function () {
      // makes no sense without proper strict mode support
      if (this !== undefined) return true;
      try {
        // eslint-disable-next-line es/no-object-defineproperty -- safe
        Object.defineProperty([], 'length', { writable: false }).length = 1;
      } catch (error) {
        return error instanceof TypeError;
      }
    }();

    var arraySetLength = SILENT_ON_NON_WRITABLE_LENGTH_SET ? function (O, length) {
      if (isArray(O) && !getOwnPropertyDescriptor(O, 'length').writable) {
        throw new $TypeError$1('Cannot set read only .length');
      } return O.length = length;
    } : function (O, length) {
      return O.length = length;
    };

    var tryToString = tryToString$2;

    var $TypeError = TypeError;

    var deletePropertyOrThrow$1 = function (O, P) {
      if (!delete O[P]) throw new $TypeError('Cannot delete property ' + tryToString(P) + ' of ' + tryToString(O));
    };

    var $$1 = _export;
    var toObject = toObject$4;
    var toAbsoluteIndex = toAbsoluteIndex$2;
    var toIntegerOrInfinity = toIntegerOrInfinity$3;
    var lengthOfArrayLike = lengthOfArrayLike$4;
    var setArrayLength = arraySetLength;
    var doesNotExceedSafeInteger = doesNotExceedSafeInteger$2;
    var arraySpeciesCreate = arraySpeciesCreate$3;
    var createProperty = createProperty$2;
    var deletePropertyOrThrow = deletePropertyOrThrow$1;
    var arrayMethodHasSpeciesSupport = arrayMethodHasSpeciesSupport$3;

    var HAS_SPECIES_SUPPORT = arrayMethodHasSpeciesSupport('splice');

    var max = Math.max;
    var min = Math.min;

    // `Array.prototype.splice` method
    // https://tc39.es/ecma262/#sec-array.prototype.splice
    // with adding support of @@species
    $$1({ target: 'Array', proto: true, forced: !HAS_SPECIES_SUPPORT }, {
      splice: function splice(start, deleteCount /* , ...items */) {
        var O = toObject(this);
        var len = lengthOfArrayLike(O);
        var actualStart = toAbsoluteIndex(start, len);
        var argumentsLength = arguments.length;
        var insertCount, actualDeleteCount, A, k, from, to;
        if (argumentsLength === 0) {
          insertCount = actualDeleteCount = 0;
        } else if (argumentsLength === 1) {
          insertCount = 0;
          actualDeleteCount = len - actualStart;
        } else {
          insertCount = argumentsLength - 2;
          actualDeleteCount = min(max(toIntegerOrInfinity(deleteCount), 0), len - actualStart);
        }
        doesNotExceedSafeInteger(len + insertCount - actualDeleteCount);
        A = arraySpeciesCreate(O, actualDeleteCount);
        for (k = 0; k < actualDeleteCount; k++) {
          from = actualStart + k;
          if (from in O) createProperty(A, k, O[from]);
        }
        A.length = actualDeleteCount;
        if (insertCount < actualDeleteCount) {
          for (k = actualStart; k < len - actualDeleteCount; k++) {
            from = k + actualDeleteCount;
            to = k + insertCount;
            if (from in O) O[to] = O[from];
            else deletePropertyOrThrow(O, to);
          }
          for (k = len; k > len - actualDeleteCount + insertCount; k--) deletePropertyOrThrow(O, k - 1);
        } else if (insertCount > actualDeleteCount) {
          for (k = len - actualDeleteCount; k > actualStart; k--) {
            from = k + actualDeleteCount - 1;
            to = k + insertCount - 1;
            if (from in O) O[to] = O[from];
            else deletePropertyOrThrow(O, to);
          }
        }
        for (k = 0; k < insertCount; k++) {
          O[k + actualStart] = arguments[k + 2];
        }
        setArrayLength(O, len - actualDeleteCount + insertCount);
        return A;
      }
    });

    var getBuiltInPrototypeMethod$1 = getBuiltInPrototypeMethod$7;

    var splice$6 = getBuiltInPrototypeMethod$1('Array', 'splice');

    var isPrototypeOf$1 = objectIsPrototypeOf;
    var method$1 = splice$6;

    var ArrayPrototype$1 = Array.prototype;

    var splice$5 = function (it) {
      var own = it.splice;
      return it === ArrayPrototype$1 || (isPrototypeOf$1(ArrayPrototype$1, it) && own === ArrayPrototype$1.splice) ? method$1 : own;
    };

    var parent$5 = splice$5;

    var splice$4 = parent$5;

    var parent$4 = splice$4;

    var splice$3 = parent$4;

    var parent$3 = splice$3;

    var splice$2 = parent$3;

    var splice$1 = splice$2;

    var splice = splice$1;

    var _spliceInstanceProperty = /*@__PURE__*/getDefaultExportFromCjs(splice);

    var $forEach = arrayIteration.forEach;
    var arrayMethodIsStrict = arrayMethodIsStrict$2;

    var STRICT_METHOD = arrayMethodIsStrict('forEach');

    // `Array.prototype.forEach` method implementation
    // https://tc39.es/ecma262/#sec-array.prototype.foreach
    var arrayForEach = !STRICT_METHOD ? function forEach(callbackfn /* , thisArg */) {
      return $forEach(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
    // eslint-disable-next-line es/no-array-prototype-foreach -- safe
    } : [].forEach;

    var $ = _export;
    var forEach$7 = arrayForEach;

    // `Array.prototype.forEach` method
    // https://tc39.es/ecma262/#sec-array.prototype.foreach
    // eslint-disable-next-line es/no-array-prototype-foreach -- safe
    $({ target: 'Array', proto: true, forced: [].forEach !== forEach$7 }, {
      forEach: forEach$7
    });

    var getBuiltInPrototypeMethod = getBuiltInPrototypeMethod$7;

    var forEach$6 = getBuiltInPrototypeMethod('Array', 'forEach');

    var parent$2 = forEach$6;

    var forEach$5 = parent$2;

    var classof = classof$2;
    var hasOwn = hasOwnProperty_1;
    var isPrototypeOf = objectIsPrototypeOf;
    var method = forEach$5;


    var ArrayPrototype = Array.prototype;

    var DOMIterables = {
      DOMTokenList: true,
      NodeList: true
    };

    var forEach$4 = function (it) {
      var own = it.forEach;
      return it === ArrayPrototype || (isPrototypeOf(ArrayPrototype, it) && own === ArrayPrototype.forEach)
        || hasOwn(DOMIterables, classof(it)) ? method : own;
    };

    var parent$1 = forEach$4;

    var forEach$3 = parent$1;

    var parent = forEach$3;

    var forEach$2 = parent;

    var forEach$1 = forEach$2;

    var forEach = forEach$1;

    var _forEachInstanceProperty = /*@__PURE__*/getDefaultExportFromCjs(forEach);

    var num2Array = function num2Array(arg) {
      if (arg === undefined) {
        return [];
      }
      return lodashEs.isNumber(arg) ? [arg] : arg;
    };

    var useTree = function useTree() {
      var _a = React.useContext(basicContext),
        tree = _a[0],
        setTree = _a[1];
      var createNode = function createNode(_a) {
        var _context;
        var _b = _a.nodeTitle,
          nodeTitle = _b === void 0 ? 'title' : _b,
          _c = _a.nodeText,
          nodeText = _c === void 0 ? 'content' : _c,
          _d = _a.nodeType,
          nodeType = _d === void 0 ? 0 : _d,
          _e = _a.disabled,
          disabled = _e === void 0 ? false : _e,
          childrenId = _a.childrenId;
        var curMaxNodeId = lodashEs.max(_mapInstanceProperty(_context = tree.nodeList).call(_context, function (_a) {
          var nodeId = _a.nodeId;
          return nodeId;
        }));
        return __assign({
          nodeId: curMaxNodeId === undefined ? 0 : curMaxNodeId + 1,
          nodeType: nodeType,
          nodeTitle: nodeTitle,
          nodeText: nodeText,
          disabled: disabled
        }, childrenId !== undefined ? {
          childrenId: childrenId
        } : {});
      };
      var searchNode = function searchNode(targetId) {
        var _context2;
        var node = _findInstanceProperty(_context2 = tree.nodeList).call(_context2, function (item) {
          return item.nodeId === targetId;
        });
        if (node === undefined) {
          throw new Error('The node is not in the tree, please check the input parameters.');
        }
        return node;
      };
      var insertNode = function insertNode(parentId, options) {
        var _context3, _context4;
        if (options === void 0) {
          options = {};
        }
        var nNode = createNode(options);
        var nTreeConfig = lodashEs.cloneDeep(tree);
        var parentNodePosition = _findIndexInstanceProperty(_context3 = nTreeConfig.nodeList).call(_context3, function (_a) {
          var nodeId = _a.nodeId;
          return nodeId === parentId;
        });
        var parentNodeChildrenLength = num2Array(nTreeConfig.nodeList[parentNodePosition].childrenId).length;
        lodashEs.set(nTreeConfig, _concatInstanceProperty(_context4 = "nodeList[".concat(parentNodePosition, "].childrenId[")).call(_context4, parentNodeChildrenLength, "]"), nNode.nodeId);
        nTreeConfig.nodeList.push(nNode);
        setTree(nTreeConfig);
      };
      var updateNode = function updateNode(targetId, options) {
        var _context5;
        if (options === void 0) {
          options = {};
        }
        var position = _findIndexInstanceProperty(_context5 = tree.nodeList).call(_context5, function (_a) {
          var nodeId = _a.nodeId;
          return nodeId === targetId;
        });
        if (position === -1) {
          throw new Error('The node is not in the tree, please check the input parameters.');
        }
        var nNode = __assign(__assign({}, tree.nodeList[position]), options);
        lodashEs.set(tree, "nodeList[".concat(position, "]"), nNode);
        setTree(tree);
      };
      var deleteNode = function deleteNode(targetId) {
        var nTree = lodashEs.cloneDeep(tree);
        for (var index = 0; index < nTree.nodeList.length; index++) {
          var childrenId = nTree.nodeList[index].childrenId;
          var childrenIdArr = num2Array(childrenId);
          var position = _indexOfInstanceProperty(childrenIdArr).call(childrenIdArr, targetId);
          if (position === -1) {
            continue;
          }
          if (_Array$isArray(childrenId)) {
            _spliceInstanceProperty(childrenId).call(childrenId, position, 1);
          }
          if (typeof childrenId === 'number') {
            delete nTree.nodeList[index].childrenId;
          }
          break;
        }
        (function ergodic(id, _context6, _context7) {
          var position = _findIndexInstanceProperty(_context6 = nTree.nodeList).call(_context6, function (_a) {
            var nodeId = _a.nodeId;
            return nodeId === id;
          });
          if (position === -1) {
            throw new Error('The node is not in the tree, please check the input parameters.');
          }
          var childrenIdArr = num2Array(nTree.nodeList[position].childrenId);
          _spliceInstanceProperty(_context7 = nTree.nodeList).call(_context7, position, 1);
          _forEachInstanceProperty(childrenIdArr).call(childrenIdArr, function (nodeId) {
            ergodic(nodeId);
          });
        })(targetId);
        setTree(nTree);
      };
      return {
        tree: tree,
        setTree: setTree,
        createNode: createNode,
        insertNode: insertNode,
        updateNode: updateNode,
        searchNode: searchNode,
        deleteNode: deleteNode
      };
    };

    var prefix$3 = "".concat(CLASS_PREFIX, "-auxiliary-line");
    var AuxiliaryLine = function AuxiliaryLine(_a) {
      var auxiliaryType = _a.auxiliaryType;
      if (auxiliaryType === AuxiliaryType.Null) {
        return '';
      }
      if (auxiliaryType === AuxiliaryType.Only) {
        return /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefix$3, "-only")
        });
      }
      if (auxiliaryType === AuxiliaryType.Head) {
        return /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefix$3, "-head")
        });
      }
      if (auxiliaryType === AuxiliaryType.Last) {
        return /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefix$3, "-last")
        });
      }
      return /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix$3, "-mid")
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix$3, "-mid-inner")
      }));
    };
    var AuxiliaryLine$1 = /*#__PURE__*/React.memo(AuxiliaryLine);

    var prefix$2 = "".concat(CLASS_PREFIX, "-node");
    var TreeNode = function TreeNode(_a) {
      var _context, _context2, _context3;
      var rootRendering = _a.rootRendering,
        leafRendering = _a.leafRendering,
        nodeId = _a.nodeId;
      var _b = useTree(),
        searchNode = _b.searchNode,
        insertNode = _b.insertNode,
        deleteNode = _b.deleteNode;
      var _c = React.useContext(optionContext),
        options = _c.options,
        curSelectedNodeId = _c.curSelectedNodeId,
        setCurSelectedNodeId = _c.setCurSelectedNodeId;
      var treeNode = searchNode(nodeId);
      var nodeText = treeNode.nodeText,
        nodeTitle = treeNode.nodeTitle,
        disabled = treeNode.disabled;
      var isSelected = curSelectedNodeId === nodeId;
      var handleInsertButtonClick = function handleInsertButtonClick() {
        var _a;
        (_a = options === null || options === void 0 ? void 0 : options.insertNodeClick) === null || _a === void 0 ? void 0 : _a.call(options);
        insertNode(nodeId);
      };
      var handleDeleteButtonClick = function handleDeleteButtonClick(e) {
        var _a;
        e.stopPropagation();
        if (isSelected) {
          setCurSelectedNodeId(null);
        }
        (_a = options === null || options === void 0 ? void 0 : options.deleteNodeClick) === null || _a === void 0 ? void 0 : _a.call(options, treeNode);
        deleteNode(nodeId);
      };
      var handleTreeNodeClick = function handleTreeNodeClick() {
        var _a;
        setCurSelectedNodeId(nodeId);
        (_a = options === null || options === void 0 ? void 0 : options.onTreeNodeClick) === null || _a === void 0 ? void 0 : _a.call(options, treeNode);
      };
      return /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix$2, "-wrapper")
      }, !rootRendering && /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix$2, "-top-line")
      }), /*#__PURE__*/React.createElement("div", {
        className: _concatInstanceProperty(_context = _concatInstanceProperty(_context2 = _concatInstanceProperty(_context3 = "".concat(options.treeNodeClassName, " ")).call(_context3, prefix$2, "-content ")).call(_context2, disabled ? "".concat(prefix$2, "-content-disabled") : '', " ")).call(_context, isSelected ? "".concat(prefix$2, "-content-selected") : ''),
        style: options.treeNodeStyle,
        onClick: handleTreeNodeClick
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix$2, "-content-title-wrapper")
      }, nodeTitle), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix$2, "-content-word-wrapper")
      }, nodeText), isSelected && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix$2, "-content-insert"),
        onClick: handleInsertButtonClick
      }), !rootRendering && /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix$2, "-content-delete"),
        onClick: handleDeleteButtonClick
      }))), !leafRendering && /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix$2, "-bot-line")
      }));
    };

    var prefix$1 = "".concat(CLASS_PREFIX);
    var ErgodicRender = function ErgodicRender(_a) {
      var _context;
      var parentId = _a.parentId,
        nodeId = _a.nodeId;
      var searchNode = useTree().searchNode;
      var childrenId = searchNode(nodeId).childrenId;
      var rootRendering = parentId === null;
      var leafRendering = lodashEs.isEmpty(childrenId);
      var auxiliaryType = function () {
        if (rootRendering) {
          return AuxiliaryType.Null;
        }
        var curNode = searchNode(parentId);
        var childrenIdArr = num2Array(curNode.childrenId);
        if (childrenIdArr.length === 1) {
          return AuxiliaryType.Only;
        }
        if (lodashEs.head(childrenIdArr) === nodeId) {
          return AuxiliaryType.Head;
        }
        if (lodashEs.last(childrenIdArr) === nodeId) {
          return AuxiliaryType.Last;
        }
        return AuxiliaryType.Mid;
      }();
      return /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix$1, "-wrapper"),
        key: nodeId
      }, /*#__PURE__*/React.createElement(AuxiliaryLine$1, {
        auxiliaryType: auxiliaryType
      }), /*#__PURE__*/React.createElement(TreeNode, {
        rootRendering: rootRendering,
        leafRendering: leafRendering,
        nodeId: nodeId
      }), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix$1, "-child-outer")
      }, _mapInstanceProperty(_context = num2Array(childrenId)).call(_context, function (id, key) {
        return /*#__PURE__*/React.createElement(ErgodicRender, {
          parentId: nodeId,
          nodeId: id,
          key: key
        });
      })));
    };

    var prefix = "".concat(CLASS_PREFIX);
    var Entry = function Entry(_a) {
      var _b = _a.tree,
        tree = _b === void 0 ? initialValue : _b,
        props = __rest(_a, ["tree"]);
      var _c = React.useState(tree),
        treeConfig = _c[0],
        setTree = _c[1];
      var _d = React.useState(null),
        curSelectedNodeId = _d[0],
        setCurSelectedNodeId = _d[1];
      var rootId = treeConfig === null || treeConfig === void 0 ? void 0 : treeConfig.rootId;
      return /*#__PURE__*/React.createElement(basicContext.Provider, {
        value: [treeConfig, setTree]
      }, /*#__PURE__*/React.createElement(optionContext.Provider, {
        value: {
          options: props,
          curSelectedNodeId: curSelectedNodeId,
          setCurSelectedNodeId: setCurSelectedNodeId
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix, "-container")
      }, /*#__PURE__*/React.createElement(ErgodicRender, {
        parentId: null,
        nodeId: rootId
      }))));
    };

    exports.Tree = Entry;
    exports.useTree = useTree;

}));
